
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <math.h>
#include <errno.h>

main(argc, argv)
   
   int	argc;
   char	**argv;
{
   unsigned long	remoteaddr = -1, get_addr();

   if(argc == 1) exit(0);

   remoteaddr = get_addr(argv[1]);
   if(test_net(remoteaddr))
      printf("net ok\n");
   else
      printf("net not ok\n");
   exit(0);
}

test_net(addr)

   unsigned long	addr;
{
   int			net;
   struct in_addr	taddr;
   char			buf[80];
   FILE			*pi;

   taddr.s_addr = addr;
   taddr = inet_makeaddr(inet_netof(taddr), 0);
   printf("%s\n", inet_ntoa(taddr));

   sprintf(buf, "/usr/etc/ping %s 2", inet_ntoa(taddr));
   pi = popen(buf, "r");
   while(fgets(buf, 78, pi)){
      if(strstr(buf, "is alive"))
	 return 1;
   }
   return 0;
}
   

unsigned long
get_addr(name)

   char *name;
{
   struct hostent       *gethostbyname(), *hent;
   unsigned long	addr;

   addr = inet_addr(name);
   if(addr != -1)
      return addr;

   hent = gethostbyname(name);
   if(!hent)
      return -1;

   /* NOTE: looking at only first address. Could miss an address for servers
      with multiple addresses */

   return  (**((struct in_addr **)hent->h_addr_list)).s_addr;
}
